<?php

// Form actions
function bp_gtm_form_action($page = false) {
    echo bp_gmt_get_form_action($page);
}

function bp_gmt_get_form_action($page = false, $group = false) {
    global $bp, $groups_template;

    if (!$group)
        $group = & $groups_template->group;

    if (!$page)
        $page = $bp->action_variables[0];

    return apply_filters('bp_gtm_form_action', bp_get_group_permalink($group) . $bp->gtm->slug . '/' . $page);
}

function bp_gtm_p_form_action($user_id) {
    echo bp_gmt_get_p_form_action($user_id);
}

function bp_gmt_get_p_form_action($user_id, $page = false) {
    global $bp;

    if (!$page)
        $page = $bp->current_action;

    return apply_filters('bp_gtm_p_form_action', $bp->loggedin_user->domain . $bp->gtm->slug . '/' . $page);
}

function bp_gtm_get_checked($var, $value) {
    if ($var == $value)
        return 'checked="checked"';
}

/*
 *  Autocomplete functions
 */

function bp_gtm_get_resp_tabs() {
    global $bp;

    if (isset($_GET['r'])) {
        $user_id = bp_core_get_userid($_GET['r']);

        if ($user_id) {
            ?>
            <li id="un-<?php echo $_GET['r'] ?>" class="resps-tab">
                <span>
                    <?php echo bp_core_fetch_avatar(array('item_id' => $user_id, 'type' => 'thumb', 'width' => 15, 'height' => 15)) ?>
                    <?php echo bp_core_get_userlink($user_id) ?>
                </span>
            </li>
            <?php
        }
    }
}

/* AJAX autocomplete users/terms on the create|edit screen */

function bp_gtm_search_users($search_terms, $limit = 10, $page = 1, $populate_extras = true) {
    return BP_Core_User::search_users($search_terms, $limit, $page, $populate_extras);
}

function bp_gtm_search_terms($search_terms, $taxon = 'tag', $limit = 10) {
    return BP_GTM_Taxon::search_terms($search_terms, $taxon, $limit);
}

function bp_gtm_resp_usernames() {
    echo bp_gtm_get_resp_usernames();
}

function bp_gtm_get_resp_usernames() {
    return apply_filters('bp_gtm_get_project_resp_usernames', $_GET['r']);
}

function bp_gtm_tag_names() {
    echo bp_gtm_get_tag_names();
}

function bp_gtm_get_tag_names() {
    return apply_filters('bp_gtm_get_project_tag_names', $_GET['r']);
}

function bp_gtm_get_el_name_by_id($elem_id, $el_type) {
    global $bp, $wpdb;

    if ($el_type == 'task' || $el_type == 'tasks') {
        $data = $wpdb->get_results($wpdb->prepare("SELECT `name` FROM " . $bp->gtm->table_tasks . " WHERE `id` = %d", $elem_id));
    } elseif ($el_type == 'project' || $el_type == 'projects') {
        $data = $wpdb->get_results($wpdb->prepare("SELECT `name` FROM " . $bp->gtm->table_projects . " WHERE `id` = %d", $elem_id));
    }

    $el_name = !empty($data[0]->name) ? $data[0]->name : '';

    return $el_name;
}

function bp_gtm_is_belong_2group($group_id, $element_id, $type) {
    global $bp, $wpdb;

    switch ($type) {
        case 'tag':
            $exist = $wpdb->get_results($wpdb->prepare("SELECT `id` FROM " . $bp->gtm->table_terms . " WHERE `id` = %d AND `group_id` = %d AND taxon='tag'", $element_id, $group_id));
            break;
        case 'cat':
            $exist = $wpdb->get_results($wpdb->prepare("SELECT `id` FROM " . $bp->gtm->table_terms . " WHERE `id` = %d AND `group_id` = %d AND taxon='cat'", $element_id, $group_id));
            break;
        case 'task':
            $exist = $wpdb->get_results($wpdb->prepare("SELECT `id` FROM " . $bp->gtm->table_tasks . " WHERE `id` = %d AND `group_id` = %d", $element_id, $group_id));
            break;
        case 'project':
            $exist = $wpdb->get_results($wpdb->prepare("SELECT `id` FROM " . $bp->gtm->table_projects . " WHERE `id` = %d AND `group_id` = %d", $element_id, $group_id));
            break;
    }

    if (count($exist) != 0)
        return true;
}

function bp_gtm_is_elem_done($elem_id, $elem_type) {
    global $bp, $wpdb;

    if ($elem_type == 'projects') {
        $table = $bp->gtm->table_projects;
    } elseif ($elem_type == 'tasks') {
        $table = $bp->gtm->table_tasks;
    }

    $done = $wpdb->get_results($wpdb->prepare("SELECT `done` FROM $table WHERE `id` = $elem_id"));

    if ($done[0]->done == 1)
        return true;

    return false;
}

function bp_gtm_get_allcount($group_id = false, $type = 'all') {
    global $bp, $wpdb;

    if ($type == 'all') {
        if ($group_id != false) {
            $count['cats'] = count(BP_GTM_Taxon::get_terms_in_group($group_id, 'cat'));
            $count['tags'] = count(BP_GTM_Taxon::get_terms_in_group($group_id, 'tag'));
            $count['projects'] = $wpdb->get_var($wpdb->prepare("
                              SELECT COUNT(DISTINCT `id`) FROM " . $bp->gtm->table_projects . " WHERE `group_id` = '%d'", $group_id));
            $count['tasks'] = $wpdb->get_var($wpdb->prepare("
                              SELECT COUNT(DISTINCT `id`) FROM " . $bp->gtm->table_tasks . " WHERE `group_id` = '%d'", $group_id));
        } else { // no matter in which group
            $count['cats'] = $wpdb->get_var($wpdb->prepare("SELECT COUNT(DISTINCT `id`) FROM " . $bp->gtm->table_terms . " WHERE `taxon` = 'cat'"));
            $count['tags'] = $wpdb->get_var($wpdb->prepare("SELECT COUNT(DISTINCT `id`) FROM " . $bp->gtm->table_terms . " WHERE `taxon` = 'tag'"));
            $count['projects'] = $wpdb->get_var($wpdb->prepare("SELECT COUNT(DISTINCT `id`) FROM " . $bp->gtm->table_projects));
            $count['tasks'] = $wpdb->get_var($wpdb->prepare("SELECT COUNT(DISTINCT `id`) FROM " . $bp->gtm->table_tasks));
        }
    } elseif ($type == 'tags') {
        if ($group_id != false) {
            $count['tags'] = count(BP_GTM_Taxon::get_terms_in_group($group_id, 'tag'));
        } else { // no matter in which group
            $count['tags'] = $wpdb->get_var($wpdb->prepare("SELECT COUNT(DISTINCT `id`) FROM " . $bp->gtm->table_terms . " WHERE `taxon` = 'tag'"));
        }
    } elseif ($type == 'cats') {
        if ($group_id != false) {
            $count['cats'] = count(BP_GTM_Taxon::get_terms_in_group($group_id, 'cat'));
        } else { // no matter in which group
            $count['cats'] = $wpdb->get_var($wpdb->prepare("SELECT COUNT(DISTINCT `id`) FROM " . $bp->gtm->table_terms . " WHERE `taxon` = 'cat'"));
        }
    } elseif ($type == 'tasks') {
        if ($group_id != false) {
            $count['tasks'] = $wpdb->get_var($wpdb->prepare("SELECT COUNT(DISTINCT `id`) FROM " . $bp->gtm->table_tasks . " WHERE `group_id` = '%d'", $group_id));
        } else { // no matter in which group
            $count['tasks'] = $wpdb->get_var($wpdb->prepare("SELECT COUNT(DISTINCT `id`) FROM " . $bp->gtm->table_tasks));
        }
    } elseif ($type == 'projects') {
        if ($group_id != false) {
            $count['projects'] = $wpdb->get_var($wpdb->prepare("SELECT COUNT(DISTINCT `id`) FROM " . $bp->gtm->table_projects . " WHERE `group_id` = '%d'", $group_id));
        } else { // no matter in which group
            $count['projects'] = $wpdb->get_var($wpdb->prepare("SELECT COUNT(DISTINCT `id`) FROM " . $bp->gtm->table_projects));
        }
    }

    if (!$count['tags'])
        $count['tags'] = '0';
    if (!$count['cats'])
        $count['cats'] = '0';
    if (!$count['projects'])
        $count['projects'] = '0';
    if (!$count['tasks'])
        $count['tasks'] = '0';

    return $count;
}

/*
 *  AJAX functions
 */
// Autocomplete-display engine
add_action('wp_ajax_autocomplete_results', 'bp_gtm_ajax_autocomplete_results');

function bp_gtm_ajax_autocomplete_results() {
    global $bp;
    $bp_gtm_group_settings = get_option('bp_gtm_g_' . $bp->groups->current_group->id . '_settings');

    if ($_GET['type'] == 'tags') {
        $terms = false;

// Get all the group tags based on the searched terms
        if (function_exists('bp_gtm_search_terms'))
            $terms = bp_gtm_search_terms($_GET['q'], $taxon = 'tag', $_GET['limit']);

        $terms = apply_filters('bp_gtm_terms_autocomplete_list', $terms, $taxon, $_GET['limit']);

        if (count($terms) > 0) {
            foreach ((array) $terms as $term) {
                echo $term->name . '
               ';
            }
        }
        die();
    } elseif ($_GET['type'] == 'cats') {
        $terms = false;

// Get all the group tags based on the searched terms
        if (function_exists('bp_gtm_search_terms'))
            $terms = bp_gtm_search_terms($_GET['q'], $taxon = 'cat', $_GET['limit']);

        $terms = apply_filters('bp_gtm_terms_autocomplete_list', $terms, $taxon, $_GET['limit']);

        if (count($terms) > 0) {
            foreach ((array) $terms as $term) {
                echo $term->name . '
               ';
            }
        }
        die();
    }
}

// Not really ajax - but is used for it
function bp_gtm_done_link($type, $elem_id, $el_type = false) {
    if (!empty($_GET['filter']) && $_GET['filter'] == 'done') {
        if (bp_gtm_check_access($el_type . '_undone'))
            echo "<a class='undone_me' id='$elem_id' href='#' title='" . __('Mark as pending', 'bp_gtm') . "'><img height='16' width='16' src='" . WP_PLUGIN_URL . "/bp-gtm-system/_inc/images/undone.png" . "' alt='" . __('Undone', 'bp_gtm') . "' /></a>";
    }else {
        if (bp_gtm_check_access($el_type . '_done'))
            echo "<a class='done_me' id='$elem_id' href='#' title='" . __('Mark as completed', 'bp_gtm') . "'><img height='16' width='16' src='" . WP_PLUGIN_URL . "/bp-gtm-system/_inc/images/done.png" . "' alt='" . __('Done', 'bp_gtm') . "' /></a>";
    }
}

// Delete tag|cat|task|project from a full list page
add_action('wp_ajax_bp_gtm_delete_item', 'bp_gtm_delete_item');

function bp_gtm_delete_item() {
    global $bp, $wpdb;

    if ($_GET['deleteType'] == 'tag' || $_GET['deleteType'] == 'cat') {
        $wpdb->query($wpdb->prepare("DELETE FROM " . $bp->gtm->table_terms . " WHERE `id` = %d AND `group_id` = %d", $_GET['deleteItem'], $bp->groups->current_group->id));
        $wpdb->query($wpdb->prepare("DELETE FROM " . $bp->gtm->table_taxon . " WHERE `term_id` = %d AND `group_id` = %d", $_GET['deleteItem'], $bp->groups->current_group->id));
    } elseif ($_GET['deleteType'] == 'projects') {
        $wpdb->query($wpdb->prepare("DELETE FROM " . $bp->gtm->table_projects . " WHERE `id` = %d AND `group_id` = %d", $_GET['deleteItem'], $bp->groups->current_group->id));
        $wpdb->query($wpdb->prepare("DELETE FROM " . $bp->gtm->table_tasks . " WHERE `project_id` = %d AND `group_id` = %d", $_GET['deleteItem'], $bp->groups->current_group->id));
        $wpdb->query($wpdb->prepare("DELETE FROM " . $bp->gtm->table_taxon . " WHERE `project_id` = %d AND `group_id` = %d", $_GET['deleteItem'], $bp->groups->current_group->id));
        $wpdb->query($wpdb->prepare("DELETE FROM " . $bp->gtm->table_resps . " WHERE `project_id` = %d AND `group_id` = %d", $_GET['deleteItem'], $bp->groups->current_group->id));
        $wpdb->query($wpdb->prepare("DELETE FROM " . $bp->gtm->table_discuss . " WHERE `project_id` = %d AND `group_id` = %d", $_GET['deleteItem'], $bp->groups->current_group->id));
        $wpdb->query($wpdb->prepare("DELETE FROM {$bp->core->table_name_notifications} WHERE `item_id` = %d AND `secondary_item_id` = %d AND `component_name` = {$bp->gtm->slug} AND `component_action` LIKE `project_%%`", $_GET['deleteItem'], $bp->groups->current_group->id));
        $project = BP_GTM_Projects::get_project_by_id($_GET['deleteItem']);
        $resps = explode(' ', $project['0']->resp_id);
        foreach ($resps as $resp) {
            if ($resp != '') {
                $resp_id = bp_core_get_userid($resp);
                if ($resp_id != $bp->loggedin_user->id)
                    bp_core_add_notification($_GET['deleteItem'], $resp_id, $bp->gtm->slug, 'project_deleted', $bp->groups->current_group->id);
            }
        }
    }elseif ($_GET['deleteType'] == 'tasks') {
        $wpdb->query($wpdb->prepare("DELETE FROM {$bp->gtm->table_tasks} WHERE `id` = %d AND `group_id` = %d", $_GET['deleteItem'], $bp->groups->current_group->id));
        $wpdb->query($wpdb->prepare("DELETE FROM {$bp->gtm->table_taxon} WHERE `task_id` = %d AND `group_id` = %d", $_GET['deleteItem'], $bp->groups->current_group->id));
        $wpdb->query($wpdb->prepare("DELETE FROM {$bp->gtm->table_resps} WHERE `task_id` = %d AND `group_id` = %d", $_GET['deleteItem'], $bp->groups->current_group->id));
        $wpdb->query($wpdb->prepare("DELETE FROM {$bp->gtm->table_discuss} WHERE `task_id` = %d AND `group_id` = %d", $_GET['deleteItem'], $bp->groups->current_group->id));
        $wpdb->query($wpdb->prepare("DELETE FROM {$bp->core->table_name_notifications} WHERE `item_id` = %d AND `secondary_item_id` = %d AND `component_name` = {$bp->gtm->slug} AND `component_action` LIKE `task_%%`", $_GET['deleteItem'], $bp->groups->current_group->id));
        $task = BP_GTM_Tasks::get_task_by_id($_GET['deleteItem']);
        $resps = explode(' ', $task['0']->resp_id);
        foreach ($resps as $resp) {
            if ($resp != '') {
                $resp_id = bp_core_get_userid($resp);
                if ($resp_id != $bp->loggedin_user->id)
                    bp_core_add_notification($_GET['deleteItem'], $resp_id, $bp->gtm->slug, 'task_deleted', $bp->groups->current_group->id);
            }
        }
    }

    return true;
}

// Edit tag|cat name on an all terms page
add_action('wp_ajax_bp_gtm_edit_term', 'bp_gtm_edit_term');

function bp_gtm_edit_term() {
    global $bp, $wpdb;
    $wpdb->query($wpdb->prepare("UPDATE " . $bp->gtm->table_terms . " SET `name` = %s WHERE `id` = %d AND `group_id` = %d", $_GET['editName'], $_GET['editID'], $bp->groups->current_group->id));
    return true;
}

// Mark task|project as done/undone on a full list page
add_action('wp_ajax_bp_gtm_done_item', 'bp_gtm_done_item');

function bp_gtm_done_item() {
    global $bp, $wpdb;

    if ($_GET['doneAction'] == 'done') {
        if ($_GET['doneType'] == 'projects') {
            $wpdb->query($wpdb->prepare("UPDATE " . $bp->gtm->table_projects . " SET `done` = '1' WHERE `id` = %d AND `group_id` = %d", $_GET['doneID'], $bp->groups->current_group->id));
            $wpdb->query($wpdb->prepare("UPDATE " . $bp->gtm->table_tasks . " SET `done` = '1' WHERE `project_id` = %d AND `group_id` = %d", $_GET['doneID'], $bp->groups->current_group->id));
            $project = BP_GTM_Projects::get_project_by_id($_GET['doneID']);
            $resps = explode(' ', $project['0']->resp_id);
            foreach ($resps as $resp) {
                if ($resp != '') {
                    $resp_id = bp_core_get_userid($resp);
                    if ($resp_id != $bp->loggedin_user->id)
                        bp_core_add_notification($_GET['doneID'], $resp_id, $bp->gtm->slug, 'project_done', $bp->groups->current_group->id);
                }
            }
        }elseif ($_GET['doneType'] == 'tasks') {
            $wpdb->query($wpdb->prepare("UPDATE " . $bp->gtm->table_tasks . " SET `done` = '1' WHERE `id` = %d AND `group_id` = %d", $_GET['doneID'], $bp->groups->current_group->id));
            $wpdb->query($wpdb->prepare("UPDATE " . $bp->gtm->table_tasks . " SET `done` = '1' WHERE `parent_id` = %d AND `group_id` = %d", $_GET['doneID'], $bp->groups->current_group->id));
            $task = BP_GTM_Tasks::get_task_by_id($_GET['doneID']);
            $resps = explode(' ', $task['0']->resp_id);
            foreach ($resps as $resp) {
                if ($resp != '') {
                    $resp_id = bp_core_get_userid($resp);
                    if ($resp_id != $bp->loggedin_user->id)
                        bp_core_add_notification($_GET['doneID'], $resp_id, $bp->gtm->slug, 'task_done', $bp->groups->current_group->id);
                }
            }
        }
    }elseif ($_GET['doneAction'] == 'undone') {
        if ($_GET['doneType'] == 'projects') {
            $wpdb->query($wpdb->prepare("UPDATE " . $bp->gtm->table_projects . " SET `done` = '0' WHERE `id` = %d AND `group_id` = %d", $_GET['doneID'], $bp->groups->current_group->id));
//         $wpdb->query( $wpdb->prepare("UPDATE ".$bp->gtm->table_tasks." SET `done` = '0' WHERE `project_id` = %d AND `group_id` = %d", $_GET['doneID'], $bp->groups->current_group->id));
            $project = BP_GTM_Projects::get_project_by_id($_GET['doneID']);
            $resps = explode(' ', $project['0']->resp_id);
            foreach ($resps as $resp) {
                if ($resp != '') {
                    $resp_id = bp_core_get_userid($resp);
                    if ($resp_id != $bp->loggedin_user->id)
                        bp_core_add_notification($_GET['doneID'], $resp_id, $bp->gtm->slug, 'project_undone', $bp->groups->current_group->id);
                }
            }
        }elseif ($_GET['doneType'] == 'tasks') {
            $wpdb->query($wpdb->prepare("UPDATE " . $bp->gtm->table_tasks . " SET `done` = '0' WHERE `id` = %d AND `group_id` = %d", $_GET['doneID'], $bp->groups->current_group->id));
            $task = BP_GTM_Tasks::get_task_by_id($_GET['doneID']);
            $resps = explode(' ', $task['0']->resp_id);
            foreach ($resps as $resp) {
                if ($resp != '') {
                    $resp_id = bp_core_get_userid($resp);
                    if ($resp_id != $bp->loggedin_user->id)
                        bp_core_add_notification($_GET['doneID'], $resp_id, $bp->gtm->slug, 'task_undone', $bp->groups->current_group->id);
                }
            }
        }
    }
    return true;
}

//--------------------------------------------------templates functions
function bp_gtm_filter_users($resps=null) {
    global $bp;
    if (bp_group_has_members(array('per_page' => 1000, 'exclude_admins_mods' => 0))) :
        include(dirname(__File__) . '/templates/gtm/groups-member-loop.php');
    else:
        ?>

        <div id="message" class="info">
            <p><?php _e("Sorry, no members were found.", 'buddypress'); ?></p>
        </div>
    <?php
    endif;
}

function bp_gtm_truncate($text) {
    $text = stripslashes(trim($text));
    unset($matchesarray);
    preg_match('/\s+/i', $text, $matchesarray);
    if (!empty($matchesarray)) {
        return $text;
    } else {
        return substr($text, 0, 30);
    }
}

function bp_gtm_resps_loop($resps=array()) {
    global $bp;
    $count = array();
    $bp_gtm = get_option('bp_gtm');
    $arg = array('width' => 25, 'height' => 25,);
    foreach ($resps as $resp) {
        if(in_array($resp->id, $count)){continue;}//prevent duplicate users
        else {$count[] = $resp->id;}//prevent duplicate users
        if ($resp->id != 0) {
            ?>
            <tr id="<?php echo $resp->id; ?>">
                <td class="td-title">
                    <?php $arg['item_id'] = $resp->id; ?>
                    <div class="poster-name"><?php echo bp_core_fetch_avatar($arg);
            echo bp_core_get_userlink($arg['item_id']); ?></div>
                </td>
                <?php if ($bp_gtm['groups'] == 'all' || array_key_exists($bp->groups->current_group->id, $bp_gtm['groups'])) { ?>
                    <td class="td-title">
                        <?php
                        if (!$resp->role_name)
                            _e('Admin', 'bp_gtm');
                        else
                            echo $resp->role_name;
                        ?>
                    </td>
                <?php } ?>
                <td class="td-poster">
                    <?php $count_tasks = BP_GTM_Resps::get_el_count($resp->id, 'tasks', $bp->groups->current_group->id); ?>
                    <?php echo sprintf(_n('%s task', '%s tasks', $count_tasks, 'bp_gtm'), $count_tasks); ?>
                </td>
                <td class="td-group">
                    <?php
                    $count_projects = BP_GTM_Resps::get_el_count($resp->id, 'projects', $bp->groups->current_group->id);
                    echo sprintf(_n('%s project', '%s projects', $count_projects, 'bp_gtm'), $count_projects);
                    ?>
                </td>
                <td id="users" class="td-freshness">
                    <?php if (bp_gtm_check_access('involved_mention')) { ?>
                        <a href="<?php echo bp_core_get_user_domain($bp->loggedin_user->id, false, false) . BP_ACTIVITY_SLUG . '/?r=' . bp_core_get_username($resp->id, false, false) ?>" title="<?php _e('Mention this user', 'bp_gtm'); ?>">@</a> | 
                    <?php } ?>
                    <?php if (bp_gtm_check_access('involved_pm')) { ?>    
                        <a href="<?php echo bp_core_get_user_domain($bp->loggedin_user->id, false, false) . BP_MESSAGES_SLUG . '/compose/?r=' . bp_core_get_username($resp->id, false, false) ?>" title="<?php _e('Send a private meassage', 'bp_gtm'); ?>"><?php _e('PM', 'bp_gtm'); ?></a>
                    <?php } ?>
                    <?php
                    if (bp_gtm_check_access('involved_email')) {
                        echo ' | ';
                        echo '<a href="#" class="email_notify" id="' . $resp->id . '" title="' . __('Notify user about pending tasks and projects', 'bp_gtm') . '">' . __('N', 'bp_gtm') . '</a>';
                    }
                    ?>
                    <?php do_action('bp_directory_involved_actions', $resp->id); ?>
                </td>

                <?php do_action('bp_directory_involved_extra_cell') ?>
            </tr>
            <?php
            do_action('bp_directory_involved_extra_row');
        }
    }
}

function bp_gtm_terms_loop($tags=array(), $tax) {
    global $bp;
    foreach ($tags as $tag) {
        ?>
        <tr class="" id="<?php echo $tag['id']; ?>">
            <td class="td-title">
                <a class="topic-title" href="<?php echo $gtm_link . $bp->action_variables[0] . '/view/' . $tag['id'] ?>" title="<?php _e('Permalink on this term page', 'bp_gtm') ?>"><?php echo bp_gtm_truncate($tag['name']); ?></a>
            </td>
            <td class="td-postcount"><?php echo $tag['count']; ?></td>
            <td id="tag" class="td-freshness">
                <?php if (bp_gtm_check_access('taxon_edit')) { ?>
                    <a class="edit_me" id="<?php echo $tag['id']; ?>" href="#"><img height='16' width='16' src="<?php echo GTM_URL ?>_inc/images/edit.png" alt="<?php _e('Edit', 'bp_gtm') ?>" /></a>&nbsp;
                <?php } ?>
                <?php if (bp_gtm_check_access('taxon_delete')) { ?>
                    <a class="delete_me" id="<?php echo $tag['id']; ?>" href="#"><img height='16' width='16' src="<?php echo GTM_URL ?>_inc/images/delete.png" alt="<?php _e('Delete', 'bp_gtm') ?>" /></a>
                <?php } ?>
            </td>

            <?php do_action('bp_directory_' . $tax . '_extra_cell') ?>
        </tr>

        <?php do_action('bp_directory_' . $tax . '_extra_row') ?>
        <?php
    }
}

function bp_gtm_terms_nodes($elements = array(), $task_or_proj) {
    foreach ($elements as $task_id => $task_name):
        ?>
        <tr class="" id="<?php echo $task_id; ?>">
            <td class="td-title">
                <a href="<?php echo 'tasks/view/' . $task_id ?>" title="<?php _e('Permalink to this task page', 'bp_gtm') ?>"><?php echo $task_name; ?></a>
            </td>
            <td class="td-postcount">
                <?php bp_gtm_is_elem_done($task_id, $task_or_proj) ? _e('Yes', 'bp_gtm') : _e('No', 'bp_gtm'); ?>
            </td>
        </tr>
        <?php
    endforeach;
}

function bp_gtm_task_project($parent_task=0, $task=null) {
    if ($parent_task == 0) :
        ?>
        <p>
            <label for="task_project">* <?php _e('Project that this task corresponds to', 'bp_gtm'); ?></label>
            <?php
            $projects = bp_gtm_get_projects(bp_get_current_group_id(), $filter = 'alpha');
            if (count($projects) > 0) :
                ?>
            <table>
                <?php
                foreach ($projects as $project) :
                    ($task == $project->id) ? $checked = 'checked="checked" ' : $checked = '';
                    $datef = __('M jS, Y', 'bp_gtm');
                    $deadline = date_i18n($datef, strtotime($project->deadline));
                    ?>
                    <tr>
                        <td class="task-project"><input type="radio" name="task_project" value="<?php echo $project->id ?>" <?php echo $checked; ?>/><?php echo $project->name ?></td>
                        <td class="padding0"><?php _e('Deadline', 'bp_gtm') ?>: <?php echo $deadline ?></td>
                    </tr>
                <?php endforeach; ?>
            </table>
            <?php
        else :
            _e('Please create at least one project to proceed.', 'bp_gtm');
        endif;
        ?>
        </p>
        <?php
    endif;
    return count($projects);
}

function bp_gtm_term_task_edit_loop($task_id, $tax) {
    $terms = BP_GTM_Taxon::get_terms_4task(bp_get_current_group_id(), $task_id, $tax);
    if (count($terms) > 0) {
        foreach ($terms as $tag) {
            ($tag['used'] == '1') ? $used = 'checked="checked"' : $used = '';
            echo '<input name="task_old_' . $tax . 's[]" type="checkbox" ' . $used . ' value="' . stripslashes($tag['name']) . '" /> ' . stripslashes($tag['name']) . '<br>';
        }
    } else {
        $link = 'terms';
        echo sprintf(__('<p>There are no %ss to display. Create them <a href="%s" target="_blank">here</a></p>', 'bp_gtm'), $tax, $link);
    }
}

function bp_gtm_discussion_list($task_id, $tax='task', $avatar) {
    ?>
    <ul id="topic-post-list" class="item-list discussions">
        <?php
        $posts = BP_GTM_Discussion::get_posts($task_id, $tax);
        $i = 1;
        if (count($posts) > 0)
            foreach ($posts as $post) {
                ?>
                <li id="post-<?php echo $post->id; ?>" class="alt">
                    <div class="poster-meta">
                        <?php
                        $avatar['item_id'] = $post->author_id;
                        echo bp_core_fetch_avatar($avatar);
                        ?>
                        <?php echo sprintf(__('%s said %s ago:', 'bp_gtm'), bp_core_get_userlink($post->author_id), bp_core_time_since($post->date_created)) ?>
                    </div>

                    <div class="post-content"><?php echo $post->text; ?></div>

                    <?php do_action('bp_gtm_discuss_after_content', $post); ?>

                    <div class="admin-links">
                        <?php bp_gtm_discuss_admin_links($post->id, $i, $tax, $task_id); ?>
                    </div>
                </li>
                <?php $i++;
            } ?>
    </ul>
    <?php
}

function bp_gtm_get_responsibles($task_resp_id) {
    $users_logins = explode(' ', $task_resp_id);
    $arg['width'] = '25';
    $arg['height'] = '25';

    if (count($users_logins) > 1) {
        echo '<span class="responsible">' . __('Responsible', 'bp_gtm') . '</span><br>';
        foreach ($users_logins as $users_login) {
            if ($users_login != '') {
                $arg['item_id'] = bp_core_get_userid($users_login);
                ?>
                <a class="responsible-link" href="<?php echo bp_core_get_userlink($arg['item_id'], false, true); ?>" title="<?php echo bp_core_get_userlink($arg['item_id'], true, false); ?>">
                    <?php echo bp_core_fetch_avatar($arg); ?>
                </a>
                <?php
            }
        }
    } else {
        $arg['item_id'] = bp_core_get_userid($users_logins['0']);
        ?>
        <span class="responsible"><?php _e('Responsible', 'bp_gtm') ?></span><br>
        <a  class="responsible-link" href="<?php echo bp_core_get_userlink($arg['item_id'], false, true); ?>" title="<?php echo bp_core_get_userlink($arg['item_id'], true, false); ?>">
            <?php echo bp_core_fetch_avatar($arg); ?>
        </a>
        <?php
    }
}

function bp_gtm_terms_for_project($project_id, $tax) {
    $terms = BP_GTM_Taxon::get_terms_4project(bp_get_current_group_id(), $project_id, $tax);
    if (count($terms) > 0) {
        echo '<p>';
        foreach ($terms as $tag) {
            if ($tag['name'] != '') {
                ($tag['used'] == '1') ? $used = 'checked="checked"' : $used = '';
                echo '<input name="project_old_' . $tax . 's[]" type="checkbox" ' . $used . ' value="' . stripslashes($tag['name']) . '" /> ' . stripslashes($tag['name']) . '<br>';
            }
        }
        echo '</p>';
    } else {
        $link = $gtm_link . 'terms';
        echo sprintf(__('<p>There are no tags to display. Create them <a href="%s" target="_blank">here</a></p>', 'bp_gtm'), $link);
    }
}

function bp_gtm_project_list_settings() {
    $options = array();
    !empty($_GET['filter']) ? $filter = $_GET['filter'] : $filter = '';
    !empty($_GET['action']) ? $options['action'] = 'project_' . $_GET['action'] : $options['action'] = 'project_' . 'view';
    if ($filter == 'done') {
        $options['page_h4'] = __('Completed Projects', 'bp_gtm');
        $options['projects'] = bp_gtm_get_projects(bp_get_current_group_id(), $filter = 'done');
        $options['done_style'] = 'class="grey"';
    } elseif ($filter == 'alpha') {
        $options['page_h4'] = __('Projects by A/Z', 'bp_gtm');
        $options['projects'] = bp_gtm_get_projects(bp_get_current_group_id(), $filter = 'alpha');
        $options['alpha_style'] = 'class="grey"';
    } elseif ($filter == 'deadline') {
        $options['page_h4'] = __('Projects by Deadline', 'bp_gtm');
        $options['projects'] = bp_gtm_get_projects(bp_get_current_group_id(), $filter = 'deadline');
        $options['deadline_style'] = 'class="grey"';
    } else {
        $options['page_h4'] = __('Projects by Deadline', 'bp_gtm');
        $options['projects'] = bp_gtm_get_projects(bp_get_current_group_id(), $filter = 'deadline');
        $options['deadline_style'] = 'class="grey"';
    }

    return $options;
}

function bp_gtm_task_list_settings($bp_gtm_group_settings) {
    $option['per_page'] = $bp_gtm_group_settings['tasks_pp']; // how many to show
    $option['miss'] = 0; // from the very first one - need to be on the 1st page
    !empty($_GET['filter']) ? $option['filter'] = $_GET['filter'] : $option['filter'] = '';
    !empty($_GET['action']) ? $option['action'] = $_GET['action'] : $action = 'task_view';

    if (empty($_GET['project'])) {
        $option['project_id'] = false;
        if ($option['filter'] == 'done') {
            $option['page_h4'] = __('All Completed Tasks', 'bp_gtm');
            $option['tasks'] = bp_gtm_get_tasks(bp_get_current_group_id(), $option['filter'] = 'done', false, $limit);
            $option['done_style'] = 'class="grey"';
        } elseif ($option['filter'] == 'alpha') {
            $option['page_h4'] = __('Tasks by A/Z', 'bp_gtm');
            $option['tasks'] = bp_gtm_get_tasks(bp_get_current_group_id(), $option['filter'] = 'alpha', false, $limit);
            $option['alpha_style'] = 'class="grey"';
        } elseif ($option['filter'] == 'deadline') {
            $option['page_h4'] = __('Tasks by Deadline', 'bp_gtm');
            $option['tasks'] = bp_gtm_get_tasks(bp_get_current_group_id(), $option['filter'] = 'deadline', false, $limit);
            $option['deadline_style'] = 'class="grey"';
        } elseif ($option['filter'] == 'without') {
            $option['page_h4'] = __('Tasks whithout Project', 'bp_gtm');
            $option['tasks'] = bp_gtm_get_tasks(bp_get_current_group_id(), $option['filter'], false, $limit);
            $option['by_proj_style'] = 'class="grey"';
        } else {
            $option['page_h4'] = __('Tasks by Deadline', 'bp_gtm');
            $option['tasks'] = bp_gtm_get_tasks(bp_get_current_group_id(), $option['filter'] = 'deadline', false, $limit);
            $option['deadline_style'] = 'class="grey"';
        }
    } elseif (!empty($_GET['project']) && !empty($option['filter'])) {
        if ($option['filter'] == 'done') {
            $option['project_id'] = $_GET['project'];
            $option['page_h4'] = __('Completed Tasks in Project', 'bp_gtm') . ' "' . bp_gtm_get_el_name_by_id($_GET['project'], 'project') . '"';
            $option['tasks'] = bp_gtm_get_tasks(bp_get_current_group_id(), $option['filter'] = 'done', $_GET['project'], $limit);
            $option['by_proj_style'] = 'class="grey"';
        }
    } elseif (!empty($_GET['project']) && empty($option['filter'])) {
        if ($_GET['project'] == 'without') {
            $option['page_h4'] = __('Tasks whithout Project', 'bp_gtm');
            $option['tasks'] = BP_GTM_Tasks::get_task_whithout_project(bp_get_current_group_id());
            $option['by_proj_style'] = 'class="grey"';
        } else {
            $option['page_h4'] = __('Tasks by Deadline', 'bp_gtm');
            $option['tasks'] = bp_gtm_get_tasks(bp_get_current_group_id(), $option['filter'] = 'inproject', $_GET['project'], $limit);
            $option['deadline_style'] = 'class="grey"';
        }
    } else {
        $option['project_id'] = false;
        $option['page_h4'] = __('Pending Tasks in Project', 'bp_gtm') . ' "' . bp_gtm_get_el_name_by_id($_GET['project'], 'project') . '"';
        $option['tasks'] = bp_gtm_get_tasks(bp_get_current_group_id(), $option['filter'] = 'project', $_GET['project'], $limit);
        $option['view_project'] = '<a href="' . $gtm_link . 'projects/view/' . $_GET['project'] . '" class="button" title="' . __('Go to project\'s page', 'bp_gtm') . '">' . __('View Project', 'bp_gtm') . '</a>';
        $option['filter'] = $_GET['project'];
        $option['by_proj_style'] = 'class="grey"';
    }

    return $option;
}