<?php
$limit['per_page'] = $bp_gtm_group_settings['discuss_pp']; // how many to show
$limit['miss'] = 0; // from the very first one - need to be on the 1st page

if(empty($_GET['filter']) || $_GET['filter'] == 'tasks'){
   $h4_title = __('Tasks Discussions', 'bp_gtm');
 $type = 'tasks';
   $th_title = __('Task Name', 'bp_gtm');
   $posts = BP_GTM_Discussion::get_list($bp->groups->current_group->id, 'tasks', $limit);
   $styles_t_cur = 'grey';
   $styles_p_cur = '';
}elseif(!empty($_GET['filter']) && $_GET['filter'] == 'projects'){
   $h4_title = __('Projects Discussions', 'bp_gtm');
   $th_title = __('Project Name', 'bp_gtm');
   $posts = BP_GTM_Discussion::get_list($bp->groups->current_group->id, 'projects', $limit);
   $type = 'projects';
   $styles_t_cur = '';
   $styles_p_cur = 'grey';
}

?>

<h4><?php echo $h4_title; ?></h4>

<div class="pagination no-ajax">
    <div id="post-count" class="pag-count">
        <?php bp_gtm_discuss_navi($type, $bp->groups->current_group->id, $bp_gtm_group_settings['discuss_pp']); ?>
    </div>
    <div id="discuss-filter">
        <?php _e('Show: ','bp_gtm'); ?>
        <a href="<?php echo $gtm_link.'discuss?filter=tasks'; ?>" class="<?php echo $styles_t_cur ?>"><?php _e('For Tasks','bp_gtm'); ?></a> |
        <a href="<?php echo $gtm_link.'discuss?filter=projects'; ?>" class="<?php echo $styles_p_cur ?>"><?php _e('For Projects','bp_gtm'); ?></a>
    </div>
</div>

<?php if (count($posts)>0) { ?>
<table class="forum zebra">
   <thead>
      <tr>
         <th id="th-title"><?php echo $th_title ?></th>
         <th id="th-poster"><?php _e('Latest Poster', 'bp_gtm') ?></th>
         <th id="th-postcount"><?php _e('Posts', 'bp_gtm') ?></th>
         <th id="th-freshness"><?php _e('Freshness', 'bp_gtm') ?></th>
         <?php do_action('bp_gtm_discuss_extra_cell_head') ?>
      </tr>
   </thead>
   <tbody id="discuss-list">
      <?php
      foreach ((array)$posts as $post) { ?>
         <tr class="">
            <td class="td-title">
               <a class="topic-title" href="<?php echo $gtm_link.$type.'/view/'.$post->elem_id ?>" title="<?php _e('Permalink', 'bp_gtm') ?>">
                  <?php echo bp_gtm_get_el_name_by_id($post->elem_id, $type); ?>
               </a>
            </td>
            <td class="td-poster">
            <?php
               $arg['item_id'] = $post->author_id;
               $arg['width'] = '25';
               $arg['height'] = '25';
            ?>
               <div class="poster-name"><?php echo bp_core_fetch_avatar($arg); echo bp_core_get_userlink($arg['item_id']); ?></div>
            </td>
            <td class="td-postcount">
               <?php echo $post->discuss_count; ?>
            </td>
            <td class="td-freshness">
            <?php 
               $datef = __( 'M jS, Y', 'bp_gtm' );
               $date = date_i18n( $datef, strtotime( $post->date_created ) );
            ?>
               <div class="object-name center" ><?php echo $date; ?></div>
            </td>

            <?php do_action('bp_gtm_discuss_extra_cell') ?>
         </tr>
      <?php
         do_action('bp_gtm_discuss_extra_row');
      }
      do_action('bp_gtm_discuss_extra_last_row'); ?>
   </tbody>
</table>
<?php 
}else{
   echo '<div id="message" class="info"><p>'.__('There are no discussion posts to display.','bp_gtm').'</p></div>';
}
?>