<?php
$filter = !empty($_GET['filter'])?$_GET['filter']:'';
if(empty($_GET['filter']) || $_GET['filter'] == 'deadline'){
    $projects = BP_GTM_Personal::get_projects($bp->loggedin_user->id, $filter);
    $h4_title = __('Personal Projects by Deadline', 'bp_gtm');
    $styles_d_cur = 'grey';
}elseif($_GET['filter'] == 'alpha'){
    $projects = BP_GTM_Personal::get_projects($bp->loggedin_user->id, $_GET['filter']);
    $h4_title = __('Personal Projects by A/Z', 'bp_gtm');
    $styles_a_cur = 'grey';
}

?>

<h4><?php echo $h4_title; ?></h4>

<div class="pagination no-ajax">
    <div id="post-count" class="pag-count">
        <?php _e('List of projects you are responsible for.', 'bp_gtm'); ?>
    </div>
    <div id="projects-filter">
        <?php _e('Filter: ','bp_gtm'); ?>
        <a href="<?php echo $gtm_profile_link.'projects?filter=alpha'; ?>" class="<?php echo $styles_a_cur ?>"><?php _e('By A/Z','bp_gtm'); ?></a> |
        <a href="<?php echo $gtm_profile_link.'projects?filter=deadline'; ?>" class="<?php echo $styles_d_cur ?>"><?php _e('By deadline','bp_gtm'); ?></a>
    </div>
</div>

<?php if (count($projects)>0) { ?>
<table class="forum zebra">
    <thead>
        <tr>
            <th id="th-title"><?php _e('Project Name', 'bp_gtm') ?></th>
            <th id="th-poster"><?php _e('Group Name', 'bp_gtm') ?></th>
            <th id="th-poster" class="center"><?php _e('Deadline', 'bp_gtm') ?></th>
            <?php do_action('bp_gtm_personal_projects_extra_cell_head') ?>
        </tr>
    </thead>
    <tbody id="discuss-list">
        <?php
        foreach ((array)$projects as $project) { 
            $group = groups_get_group(array('group_id' => $project->group_id) ); ?>
            <tr class="">
                <td class="td-title">
                    <a class="topic-title" href="<?php echo $bp->root_domain.'/'.$bp->groups->slug.'/'.$group->slug.'/'.$bp->gtm->slug.'/projects/view/'.$project->id ?>" title="<?php _e('Permalink', 'bp_gtm') ?>">
                        <?php echo $project->name; ?>
                    </a>
                </td>
                <td class="td-poster"><!-- group name -->
                    <?php
                    echo '<a href="'.$bp->root_domain.'/'.$bp->groups->slug.'/'.$group->slug.'/" title="'.$group->description.'">'.$group->name.'</a>';
                    ?>
                </td>
                <td class="td-poster">
                    <?php
                        $datef = __( 'M jS, Y', 'bp_gtm' );
                        $date = date_i18n( $datef, strtotime( $project->deadline ) );
                    ?>
                    <div class="object-name" class="center"><?php echo $date; ?></div>
                </td>
                <?php do_action('bp_gtm_personal_projects_extra_cell') ?>
            </tr>
            <?php do_action('bp_gtm_personal_projects_extra_row');
        }
    do_action('bp_gtm_personal_projects_extra_last_row'); ?>
    </tbody>
</table>
<?php 
}else{
    echo '<div id="message" class="info"><p>'.__('You are not responsible for any projects on this site.','bp_gtm').'</p></div>';
}
?>