<?php
$options = bp_gtm_project_list_settings();

do_action('bp_gtm_delete_view_notification', $bp->loggedin_user->id, $ids = 'none', $action);
?>
<?php if (bp_gtm_check_access('project_create')) { ?>
<div id="create-button">
        <a class="button" href="<?php echo $gtm_link . $bp->action_variables[0] ?>/create"><?php _e('Create new', 'bp_gtm') ?></a>
    </div>
<?php } ?>
<h4><?php echo $options['page_h4']; ?></h4>


<div class="group-navi">
    <div class="pagination no-ajax">
        <div id="post-count" class="pag-count">
            <p><?php _e('List of projects in this group. Use links in the right to filter them.', 'bp_gtm'); ?></p>
        </div>

        <div id="projects-filter">
            <?php _e('Filter: ', 'bp_gtm'); ?>
            <a <?php if (!empty($options['alpha_style']))
                echo $options['alpha_style']; ?> href="<?php echo $gtm_link . 'projects?filter=alpha'; ?>"><?php _e('By A/Z', 'bp_gtm'); ?></a> |
            <a <?php if (!empty($options['deadline_style']))
                    echo $options['deadline_style']; ?> href="<?php echo $gtm_link . 'projects?filter=deadline'; ?>"><?php _e('By deadline', 'bp_gtm'); ?></a> |
            <a <?php if (!empty($options['done_style']))
                    echo $options['done_style']; ?> href="<?php echo $gtm_link . 'projects?filter=done'; ?>"><?php _e('Completed', 'bp_gtm'); ?></a>
        </div>
    </div>
</div>
<?php do_action('bp_before_gtm_projects_list');

if (count($options['projects'])) { ?>

    <table class="forum zebra">
        <thead>
            <tr>
                <th id="th-title"><?php _e('Project Title', 'bp_gtm') ?></th>
                <th id="th-poster"><?php _e('Responsible', 'bp_gtm') ?></th>
                <th id="th-group"><?php _e('Deadline', 'bp_gtm') ?></th>
                <th id="th-postcount"><?php _e('Tasks', 'bp_gtm') ?></th>
                <th id="th-freshness"><?php _e('Actions', 'bp_gtm') ?></th>

                <?php do_action('bp_directory_projects_extra_cell_head') ?>

            </tr>
        </thead>

        <tbody id="projects-list" >
            <?php foreach ($options['projects'] as $project) { ?>
                <tr id="<?php echo $project->id; ?>" class="<?php bp_gtm_project_check_date($project->id, $project->deadline); ?>">
                    <td class="td-title">
                        <a class="topic-title" href="<?php echo $gtm_link . $bp->action_variables[0] . '/view/' . $project->id ?>" title="<?php _e('Permalink on project\'s page', 'bp_gtm') ?>">
                            <?php echo $project->name; ?>
                        </a>
                    </td>
                    <td class="td-poster">
                        <?php
                        $users_logins = explode(' ', $project->resp_id);
                        $arg['width'] = '25';
                        $arg['height'] = '25';

                        if (count($users_logins) > 1) {
                            foreach ($users_logins as $users_login) {
                                $arg['item_id'] = bp_core_get_userid($users_login);
                                ?>
                                <div class="poster-name">
                                    <a href="<?php echo bp_core_get_userlink($arg['item_id'], false, true); ?>" title="<?php echo bp_core_get_userlink($arg['item_id'], true, false); ?>">
                                        <?php echo bp_core_fetch_avatar($arg); ?>
                                    </a>
                                </div>
                                <?php
                            }
                        } else {
                            $arg['item_id'] = bp_core_get_userid($users_logins['0']);
                            ?>
                            <div class="poster-name"><?php echo bp_core_fetch_avatar($arg);
                echo bp_core_get_userlink($arg['item_id']); ?></div>
                        <?php } ?>
                    </td>
                    <td class="td-group">
                        <?php
                        $datef = __('M jS, Y', 'bp_gtm');
                        $date = date_i18n($datef, strtotime($project->deadline));
                        ?>
                        <div class="object-name"><?php echo $date; ?></div>
                    </td>
                    <td class="td-postcount">
                        <?php
                        $count = BP_GTM_Projects::get_count_tasks($project->id, $project->group_id);
                        echo '<a href="' . $gtm_link . 'tasks?project=' . $project->id . '" title="' . __('Pending tasks', 'bp_gtm') . '">' . $count['undone'] . '</a> / <a href="' . $gtm_link . 'tasks?project=' . $project->id . '&filter=done" title="' . __('Completed tasks', 'bp_gtm') . '">' . $count['done'] . '</a>';
                        ?>
                    </td>
                    <td id="projects" class="td-freshness">
                        <?php if (bp_gtm_check_access('project_edit')) { ?>
                            <a href="<?php echo $gtm_link . $bp->action_variables[0] . '/edit/' . $project->id ?>" title="<?php _e('Edit this project', 'bp_gtm'); ?>"><img height="16" width="16" src="<?php echo WP_PLUGIN_URL . "/bp-gtm-system/_inc/images/edit.png" ?>" alt="<?php _e('Edit', 'bp_gtm') ?>" /></a>&nbsp;
                        <?php } ?>

                        <?php if (bp_gtm_check_access('project_delete')) { ?>
                            <a class="delete_me" id="<?php echo $project->id; ?>" href="#" title="<?php _e('Delete this project and all corresponding tasks', 'bp_gtm'); ?>"><img height="16" width="16" src="<?php echo WP_PLUGIN_URL . "/bp-gtm-system/_inc/images/delete.png" ?>" alt="<?php _e('Delete', 'bp_gtm') ?>" /></a>&nbsp;
                            <?php } ?>

                        <?php bp_gtm_done_link($filter, $project->id, $el_type = 'project'); ?>

                    </td>

                    <?php do_action('bp_directory_projects_extra_cell') ?>
                </tr>
                <?php do_action('bp_directory_projects_extra_row');
            } ?>
        </tbody>
    </table>

    <?php
} else {
    echo '<div id="message" class="info"><p>' . __('There are no projects to display.', 'bp_gtm') . '</p></div>';
}
?>
