<?php
$task = BP_GTM_Tasks::get_task_by_id($bp->action_variables[2]);
if (count($task) == 0){
   echo '<h4>'.__('Error - 404','bp_gtm') .'</h4>';
   echo '<p>'.__('There is no task in the database with such ID. Please go to the main tasks list.','bp_gtm') .'</p>';
   ?><a class="button back-task" href="<?php echo $gtm_link.'tasks'; ?>"><?php _e( '&larr; Back To Tasks List', 'bp_gtm') ?></a><?php
}else{
   $avatar['item_id'] = $task['0']->creator_id;
   $avatar['width'] = '40';
   $avatar['height'] = '40';
   if ($task['0']->done == 1){
      $task_status = '<span id="task_status" style="color:green;font-size:14px">&rarr; '.__('completed','bp_gtm').'</span>';
   }else{
      $task_status = '<span id="task_status" style="display:none;font-size:14px"></span>';
   }
   $action = !empty($_GET['action'])?'task_'.$_GET['action']:'task_view';

   do_action('bp_gtm_delete_view_notification', $bp->loggedin_user->id, $task['0']->id, $action );

?>

<div id="topic-meta">
    <h3>#T<?php echo $task['0']->id ?> &rarr; <a href="<?php echo $gtm_link.'tasks/view/'.$task['0']->id ?>"><?php echo $task['0']->name; ?></a> <?php echo $task_status; ?></h3>
    <a class="button back-task" href="<?php echo $gtm_link.'tasks'; ?>"><?php _e( '&larr; Back To Tasks List', 'bp_gtm') ?></a>
    <?php if ($task['0']->parent_id == '0') { ?>
         <?php if(bp_gtm_check_access('task_create')){ ?>
            <a class="button" href="<?php echo $gtm_link.'tasks/create?'.$task['0']->id; ?>" title="<?php _e( 'Create new subtask for this task', 'bp_gtm'); ?>"><?php _e( 'New SubTask', 'bp_gtm') ?></a>
        <?php } ?>
        <a class="button show_subtasks" id="<?php echo $task['0']->id ?>" href="#subtasks" title="<?php _e( 'Show SubTasks for this task', 'bp_gtm'); ?>"><?php _e( 'Show SubTasks', 'bp_gtm') ?></a>
    <?php } ?>
    <?php if ($task['0']->parent_id != '0') { ?>
        <a class="button" href="<?php echo $gtm_link.'tasks/view/'.$task['0']->parent_id; ?>" title="<?php _e( 'Go to a parent task page: ', 'bp_gtm'); echo bp_gtm_get_el_name_by_id($task['0']->parent_id, 'task'); ?>"><?php _e( 'Parent Task', 'bp_gtm') ?></a>
    <?php } ?>

    <?php if(bp_gtm_check_access('task_edit')){ ?>
        <a class="button edit-button" href="<?php echo $gtm_link.'tasks/edit/'.$task['0']->id; ?>" title="<?php _e( 'Edit this task', 'bp_gtm' ); ?>"><?php _e( 'Edit', 'bp_gtm' ); ?></a>
   <?php } ?>
        
    <?php if(bp_gtm_check_access('task_done')){ ?>
        <?php if ($task['0']->done == 0){ ?>
            <a class="button complete_task" id="<?php echo $task['0']->id ?>" href="#" title="<?php _e('Mark as completed', 'bp_gtm'); ?>"><?php _e('Complete', 'bp_gtm') ?></a>
        <?php } ?>
    <?php } ?>
   
    <?php if(bp_gtm_check_access('task_delete')){ ?>
        <a class="button delete_task" id="<?php echo $task['0']->id ?>" href="#" title="<?php _e('Delete this task', 'bp_gtm'); ?>"><?php _e('Delete', 'bp_gtm') ?></a>
    <?php } ?>

   <div class="admin-links">
      <?php
      bp_gtm_get_responsibles($task[0]->resp_id);
      do_action( 'bp_gtm_task_view_resps' ); ?>
    </div>
</div>

<?php do_action( 'bp_before_task_view_content' ) ?>

<ul id="topic-post-list" class="item-list">
   <li id="post-0" class="">
      <div class="poster-meta">
         <?php
         echo bp_core_fetch_avatar( $avatar );
         $datef = __( 'M jS, Y', 'bp_gtm' );
         $date_created = date_i18n( $datef, strtotime( $task['0']->date_created ) );
         echo sprintf( __( '%s created task on %s:', 'bp_gtm' ), bp_core_get_userlink( $task['0']->creator_id), $date_created ) ?>
      </div>

      <div class="post-content" id="">
         <?php echo $task['0']->desc; ?>
      </div>

      <div class="admin-links">
         <?php do_action( 'bp_gtm_task_desc_meta' ); ?>
         <a href="" title="<?php _e( 'Permalink to task description', 'bp_gtm' ) ?>">#</a>
      </div>
   </li>
</ul>

<div class="pagination no-ajax">
   <div id="post-count" class="pag-count">
       <?php bp_gtm_task_terms($task['0']->id, 'tag', true); ?> | <?php bp_gtm_task_terms($task['0']->id, 'cat', true); ?>
      <?php
      if($task['0']->project_id != '0'){
         echo ' | ';
         _e('Project: ', 'bp_gtm');
         echo '<a href="'.$gtm_link.'projects/view/'.$task['0']->project_id.'" title="'.__('Go to project\'s page','bp_gtm').'">'.bp_gtm_get_el_name_by_id($task['0']->project_id, 'project').'</a>';
      }
      ?>
    </div>
    <div class="pagination-links" id="topic-pag">
      <p><?php
         $datef = __( 'M jS, Y', 'bp_gtm' );
         $date_created = date_i18n( $datef, strtotime( $task['0']->deadline ) );
         _e( 'Deadline', 'bp_gtm' ); echo ': '.$date_created; ?></p>
    </div>
</div>

<div class="subtasks"></div>

<?php if ( $bp_gtm_group_settings['discuss'] == 'on' && bp_gtm_check_access('discuss_view')) { 
    bp_gtm_discussion_list($task[0]->id, 'task', $avatar);
    ?>
    <!-- #discussion-post-list -->

    <?php if (bp_gtm_check_access('discuss_create')) { ?>
        <div id="post-topic-reply">
            <p id="post-reply"></p>

            <?php do_action( 'bp_gtm_discuss_new_reply_before' ) ?>

            <h4><?php _e( 'Add a reply:', 'bp_gtm' ) ?></h4>

            <textarea name="discuss_text" id="discuss_text"></textarea>

            <input type="hidden" name="author_id" value="<?php echo $bp->loggedin_user->id ?>" />
            <input type="hidden" name="task_id" value="<?php echo $task['0']->id ?>" />
            <input type="hidden" name="project_id" value="0" />
            <input type="hidden" name="files_project_id" value="<?php echo $task['0']->project_id ?>" />
            <input type="hidden" name="group_id" value="<?php echo $task['0']->group_id ?>" />

            <?php do_action('bp_gtm_discuss_new_reply_after', $bp_gtm) ?>

            <div class="submit">
                <input type="submit" name="submitDiscuss" id="submit" value="<?php _e( 'Post Reply', 'bp_gtm' ) ?>" />
            </div>
            
            <?php wp_nonce_field('bp_gtm_discuss_new_reply') ?>
        </div><!-- #discussion-post-form -->
    <?php }
    }
} ?>
