<?php
$option = bp_gtm_task_list_settings($bp_gtm_group_settings);

do_action('bp_gtm_delete_view_notification', $bp->loggedin_user->id, $ids = 'none', $action);
?>
<div id="create-button">
        <a class="button" href="<?php echo $gtm_link . $bp->action_variables[0] ?>/create"><?php _e('Create new', 'bp_gtm') ?></a> <?php if (!empty($view_project))
        echo $view_project; ?>
    </div>
<h4><?php echo $option['page_h4']; ?></h4>
    <?php if (bp_gtm_check_access('task_create')) { ?>
    
    <?php } ?>

<div class="group-navi">
<div class="pagination no-ajax">
    <div id="post-count" class="pag-count">
        <?php bp_gtm_tasks_navi($option['filter'], $option['project_id'], $option['per_page']); ?>
        <!--<p><?php _e('List of tasks in this group. Use links in the right to filter them.', 'bp_gtm'); ?></p>-->
    </div>

    <div id="tasks-filter">
        <?php _e('Filter: ', 'bp_gtm'); ?>
        <a <?php if (!empty($option['alpha_style']))
            echo $option['alpha_style'] ?> href="<?php echo $gtm_link . 'tasks?filter=alpha'; ?>"><?php _e('By A/Z', 'bp_gtm'); ?></a> |
        <a <?php if (!empty($option['deadline_style']))
            echo $option['deadline_style'] ?> href="<?php echo $gtm_link . 'tasks?filter=deadline'; ?>"><?php _e('By deadline', 'bp_gtm'); ?></a> |
        <a <?php if (!empty($option['by_proj_style']))
            echo $option['by_proj_style'] ?> id="open" href="#"><?php _e('By project', 'bp_gtm'); ?></a> |
        <a <?php if (!empty($option['done_style']))
            echo $option['done_style'] ?> href="<?php echo $gtm_link . 'tasks?filter=done'; ?>"><?php _e('Completed', 'bp_gtm'); ?></a>

        <div id="toggler">
            <div id="box" id="box">
                <p><strong><?php _e('Projects List', 'bp_gtm') ?></strong><span class="close"><a id="open" href="#" title="<?php _e('Close', 'bp_gtm'); ?>">X</a></span></p>
                <ul class="projects-filter">
                    <li><a href="tasks?filter=without">Without Project</a></li>
                    <?php
                    $projects = bp_gtm_get_projects($bp->groups->current_group->id, $option['filter'] = 'alpha');
                    foreach ($projects as $project) {
                        echo '<li><a href="' . $gtm_link . 'tasks?project=' . $project->id . '"> ' . $project->name . '</a></li>';
                    }
                    ?>
                </ul>
                <p><small><?php _e('Click on a project to see its tasks', 'bp_gtm'); ?></small></p>
            </div>
        </div>

    </div>
</div>
</div>
<?php do_action('bp_before_gtm_tasks_list');

if (count($option['tasks']) > 0) { ?>

    <table class="item-list zebra">
        <thead>
            <tr>
                <th id="th-title"><?php _e('Task Title', 'bp_gtm') ?></th>
                <th id="th-poster"><?php _e('Responsible', 'bp_gtm') ?></th>
                <th id="th-group"><?php _e('Project', 'bp_gtm') ?></th>
                <th id="th-postcount"><?php _e('Deadline', 'bp_gtm') ?></th>
                <th id="th-freshness"><?php _e('Actions', 'bp_gtm') ?></th>

                <?php do_action('bp_directory_tasks_extra_cell_head') ?>

            </tr>
        </thead>

        <tbody id="tasks-list" >
            <?php foreach ($option['tasks'] as $task) { ?>
                <tr id="<?php echo $task->id; ?>" class="<?php bp_gtm_task_check_date($task->id, $task->deadline); ?>">

                    <td class="td-title">
                        <span class="subtasks_<?php echo $task->id; ?>">
                            <span class="all_in_all" title="<?php _e('Current number of subtasks', 'bp_gtm'); ?>"><?php echo bp_gtm_get_subtasks_count($task->id) ?></span>&nbsp;
                            <?php if (bp_gtm_check_access('task_create')) { ?>
                                <a href="<?php echo $gtm_link . $bp->action_variables[0] ?>/create?<?php echo $task->id; ?>" title="<?php _e('Create SubTask', 'bp_gtm'); ?>">
                                    <img src="<?php echo WP_PLUGIN_URL . '/bp-gtm-system/_inc/images/add.png'; ?>" alt="<?php _e('Create SubTask', 'bp_gtm'); ?>" height='16' width='16' />
                                </a>
                            <?php } ?>
                        </span>
                        <a class="topic-title" href="<?php echo $gtm_link . $bp->action_variables[0] . '/view/' . $task->id ?>" title="<?php _e('Permalink to task\'s page', 'bp_gtm') ?>">
                            <?php echo $task->name; ?>
                        </a>
                    </td>
                    <td class="td-poster">
                        <?php
                        $users_logins = explode(' ', $task->resp_id);
                        $arg['width'] = '25';
                        $arg['height'] = '25';

                        if (count($users_logins) > 1) {
                            foreach ($users_logins as $users_login) {
                                $arg['item_id'] = bp_core_get_userid($users_login);
                                ?>
                                <div class="poster-name">
                                    <a href="<?php echo bp_core_get_userlink($arg['item_id'], false, true); ?>" title="<?php echo bp_core_get_userlink($arg['item_id'], true, false); ?>">
                                        <?php echo bp_core_fetch_avatar($arg); ?>
                                    </a>
                                </div>
                                <?php
                            }
                        } else {
                            $arg['item_id'] = bp_core_get_userid($users_logins['0']);
                            ?>
                            <div class="poster-name"><?php echo bp_core_fetch_avatar($arg);
                echo bp_core_get_userlink($arg['item_id']); ?></div>
                            <?php } ?>
                    </td>
                    <td class="td-group">
                        <?php
                        if (bp_gtm_check_access('project_view')) {
                            echo '<div class="object-name">
                                    <a href="' . $gtm_link . 'projects/view/' . $task->project_id . '" title="' . __('Go to project\'s page', 'bp_gtm') . '">
                                        ' . bp_gtm_get_el_name_by_id($task->project_id, 'project') . '
                                    </a>
                               </div>';
                        } else {
                            _e('Access denied', 'bp_gtm');
                        }
                        ?>
                    </td>
                    <td class="td-group">
                        <?php
                        $datef = __('M jS, Y', 'bp_gtm');
                        $date = date_i18n($datef, strtotime($task->deadline));
                        ?>
                        <div class="object-name center"><?php echo $date; ?></div>
                    </td>
                    <td id="tasks" class="td-freshness center">

                        <?php if (bp_gtm_check_access('task_edit')) { ?>
                        <a href="<?php echo $gtm_link . $bp->action_variables[0] . '/edit/' . $task->id ?>" title="<?php _e('Edit this task', 'bp_gtm'); ?>"><img height="16" width="16" src="<?php echo WP_PLUGIN_URL . "/bp-gtm-system/_inc/images/edit.png" ?>" alt="<?php _e('Edit', 'bp_gtm') ?>" /></a>&nbsp;
                        <?php } ?>

                        <?php if (bp_gtm_check_access('task_delete')) { ?>
                            <a class="delete_me" id="<?php echo $task->id; ?>" href="#" title="<?php _e('Delete this task', 'bp_gtm'); ?>"><img height="16" width="16" src="<?php echo WP_PLUGIN_URL . "/bp-gtm-system/_inc/images/delete.png" ?>" alt="<?php _e('Delete', 'bp_gtm') ?>" /></a>&nbsp;
                            <?php } ?>

                        <?php bp_gtm_done_link($option['filter'], $task->id, $el_type = 'task'); ?>

                    </td>

                    <?php do_action('bp_directory_tasks_extra_cell') ?>
                </tr>
                <?php do_action('bp_directory_tasks_extra_row');
            } ?>
        </tbody>
    </table>
    <?php
} else {
    echo '<div id="message" class="info"><p>' . __('There are no tasks to display.', 'bp_gtm') . '</p></div>';
}
?>